diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 1b9dd2b76..bb0dec3aa 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -92,6 +92,7 @@ public final class Blocks {
     public static Block BRICK_STONE;
     public static Block BRICK_PERMAFROST;
     public static Block BRICK_IRON;
+    public static Block BRICK_STEEL;
 
     public static Block SLAB_PLANKS_OAK;
     public static Block SLAB_COBBLE_STONE;
@@ -485,17 +486,17 @@ public final class Blocks {
         PERMAFROST = new StoneBlock("permafrost", "minecraft:block/permafrost", 7, () -> Blocks.COBBLE_PERMAFROST, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
 
-        COBBLE_STONE = new Block("cobble.stone", "minecraft:block/cobble_stone", 10, Material.stone).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_STONE = new CobbleBlock("cobble.stone", "minecraft:block/cobble_stone", 10, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_STONE_MOSSY = new Block("cobble.stone.mossy", "minecraft:block/cobble_stone_mossy", 11, Material.stone).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_STONE_MOSSY = new CobbleBlock("cobble.stone.mossy", "minecraft:block/cobble_stone_mossy", 11, Material.stone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_BASALT = new Block("cobble.basalt", "minecraft:block/cobble_basalt", 12, Material.basalt).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_BASALT = new CobbleBlock("cobble.basalt", "minecraft:block/cobble_basalt", 12, Material.basalt, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_LIMESTONE = new Block("cobble.limestone", "minecraft:block/cobble_limestone", 13, Material.limestone).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_LIMESTONE = new CobbleBlock("cobble.limestone", "minecraft:block/cobble_limestone", 13, Material.limestone, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_GRANITE = new Block("cobble.granite", "minecraft:block/cobble_granite", 14, Material.granite).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_GRANITE = new CobbleBlock("cobble.granite", "minecraft:block/cobble_granite", 14, Material.granite, () -> GRAVEL).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_PERMAFROST = new Block("cobble.permafrost", "minecraft:block/cobble_permafrost", 15, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F)
+        COBBLE_PERMAFROST = new CobbleBlock("cobble.permafrost", "minecraft:block/cobble_permafrost", 15, Material.permafrost, () -> GRAVEL).withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         STONE_POLISHED = new Block("stone.polished", "minecraft:block/stone_polished", 860, Material.stone).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
@@ -596,6 +597,8 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         BRICK_IRON = new Block("brick.iron", "minecraft:block/brick_iron", 133, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(10F).withOverrideColor(MaterialColor.iron)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        BRICK_STEEL = new Block("brick.steel", "minecraft:block/brick_steel", 134, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withOverrideColor(MaterialColor.steel)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         SLAB_PLANKS_OAK = new PaintableSlabBlock(PLANKS_OAK, "minecraft:block/slab_planks_oak", 140).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_AXE);
@@ -930,7 +933,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         BLOCK_NETHER_COAL = new Block("block.nethercoal", "minecraft:block/block_nethercoal", 436, Material.netherrack).withSound(BlockSounds.STONE).withHardness(3F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        BLOCK_STEEL = new Block("block.steel", "minecraft:block/block_steel", 437, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withOverrideColor(MaterialColor.steel)
+        BLOCK_STEEL = new Block("block.steel", "minecraft:block/block_steel", 437, Material.steel).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withOverrideColor(MaterialColor.steel)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         BLOCK_QUARTZ = new Block("block.quartz", "minecraft:block/block_quartz", 438, Material.stone).withSound(BlockSounds.STONE).withHardness(3F).withBlastResistance(10F).withOverrideColor(MaterialColor.quartz)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1010,7 +1013,7 @@ public final class Blocks {
         TRAPDOOR_PLANKS_PAINTED = new PaintedTrapDoorBlock("trapdoor.planks.oak.painted", "minecraft:block/trapdoor_planks_oak_painted", 573, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .setBlockItem((b) -> new PaintedBlockItem(b, true))
             .withTags(BlockTags.MINEABLE_BY_AXE);
-        TRAPDOOR_STEEL = new TrapDoorBlock("trapdoor.steel", "minecraft:block/trapdoor_steel", 574, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel)
+        TRAPDOOR_STEEL = new TrapDoorBlock("trapdoor.steel", "minecraft:block/trapdoor_steel", 574, Material.metal).withSound(BlockSounds.METAL).withOverrideColor(MaterialColor.steel).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         TNT = new TNTBlock("tnt", "minecraft:block/tnt", 580).withSound(BlockSounds.GRASS).withHardness(0.0F);
@@ -1033,9 +1036,9 @@ public final class Blocks {
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
         DOOR_GLASS_TOP = new DoorBlock("door.glass.top", "minecraft:block/door_glass_top", 597, Material.glass, true, false, () -> Items.DOOR_GLASS).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_GLASS_BOTTOM)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-        DOOR_STEEL_BOTTOM = new DoorBlock("door.steel.bottom", "minecraft:block/door_steel_bottom", 598, Material.metal, false, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> Items.DOOR_STEEL)
+        DOOR_STEEL_BOTTOM = new DoorBlock("door.steel.bottom", "minecraft:block/door_steel_bottom", 598, Material.metal, false, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withOverrideColor(MaterialColor.steel).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> Items.DOOR_STEEL)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-        DOOR_STEEL_TOP = new DoorBlock("door.steel.top", "minecraft:block/door_steel_top", 599, Material.metal, true, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> DOOR_STEEL_BOTTOM)
+        DOOR_STEEL_TOP = new DoorBlock("door.steel.top", "minecraft:block/door_steel_top", 599, Material.metal, true, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withOverrideColor(MaterialColor.steel).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> DOOR_STEEL_BOTTOM)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
         MESH = new MeshBlock("mesh", "minecraft:block/mesh", 600).withSound(BlockSounds.METAL).withHardness(1.5F)
@@ -1145,11 +1148,11 @@ public final class Blocks {
         PUMPKIN_REDSTONE = new RedstonePumpkinBlock("pumpkin.redstone", "minecraft:block/pumpkin_redstone", 793).withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange();
 
 
-        COBBLE_NETHERRACK = new Block("cobble.netherrack", "minecraft:block/cobble_netherrack", 800, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
+        COBBLE_NETHERRACK = new CobbleBlock("cobble.netherrack", "minecraft:block/cobble_netherrack", 800, Material.netherrack, null).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
-        COBBLE_NETHERRACK_IGNEOUS = new Block("cobble.netherrack.igneous", "minecraft:block/cobble_netherrack_igneous", 801, Material.netherrack).withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
+        COBBLE_NETHERRACK_IGNEOUS = new IgneousNetherrackBlock("cobble.netherrack.igneous", "minecraft:block/cobble_netherrack_igneous", 801).withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        COBBLE_NETHERRACK_MOSSY = new Block("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
+        COBBLE_NETHERRACK_MOSSY = new CobbleBlock("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, Material.netherrack, null).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
         NETHERRACK = new StoneBlock("netherrack", "minecraft:block/netherrack", 803, () -> Blocks.COBBLE_NETHERRACK, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.32F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
@@ -1168,7 +1171,8 @@ public final class Blocks {
 
         SOULSAND = new SoulSandBlock("soulsand", "minecraft:block/soulsand", 810).withSound(BlockSounds.SAND).withHardness(0.5F).withOverrideColor(MaterialColor.paintedBrown)
             .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
-        SOULSCHIST = new Block("soulschist", "minecraft:block/soulschist", 811, Material.stone).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.paintedBrown)
+        SOULSCHIST = new CobbleBlock("soulschist", "minecraft:block/soulschist", 811, Material.stone, () -> Blocks.SOULSAND).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.paintedBrown)
+
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NETHER_MOBS_SPAWN);
 
         GLOWSTONE = new GlowStoneBlock("glowstone", "minecraft:block/glowstone", 820, Material.stone).withSound(BlockSounds.GLASS).withHardness(0.3F).withLightEmission(1.0F).withOverrideColor(MaterialColor.paintedYellow)
@@ -1208,7 +1212,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAN_HANG_OFF);
         FENCE_PAPER_WALL = new PaperWallFenceBlock("fence.paper_wall", "minecraft:block/fence_paper_wall", 891, Material.cloth).withSound(BlockSounds.CLOTH).withHardness(0.5F)
             .withTags(BlockTags.MINEABLE_BY_SHEARS, BlockTags.FENCES_CONNECT, BlockTags.CAN_HANG_OFF, BlockTags.MINEABLE_BY_AXE);
-        FENCE_STEEL = new SteelFenceBlock("fence.steel", "minecraft:block/fence_steel", 892, Material.metal).withSound(BlockSounds.METAL).withHardness(8F).withBlastResistance(2000F)
+        FENCE_STEEL = new SteelFenceBlock("fence.steel", "minecraft:block/fence_steel", 892, Material.metal).withSound(BlockSounds.METAL).withHardness(8F).withOverrideColor(MaterialColor.steel).withBlastResistance(2000F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAN_HANG_OFF);
 
         BASKET = new BasketBlock("basket", "minecraft:block/basket", 900, Material.cloth).withSound(BlockSounds.CLOTH).withHardness(0.5F).withOverrideColor(MaterialColor.wood).setStatParent(() -> Items.BASKET)
diff --git a/src/main/java/net/minecraft/core/block/CoalOreBlock.java b/src/main/java/net/minecraft/core/block/CoalOreBlock.java
index cc31f1568..efdef2903 100644
--- a/src/main/java/net/minecraft/core/block/CoalOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/CoalOreBlock.java
@@ -32,6 +32,7 @@ public class CoalOreBlock extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.COAL) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/CobbleBlock.java b/src/main/java/net/minecraft/core/block/CobbleBlock.java
new file mode 100644
index 000000000..a2c65846e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/CobbleBlock.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+import java.util.function.Supplier;
+
+public class CobbleBlock extends Block{
+    private final Supplier<IItemConvertible> crushDrop;
+    public CobbleBlock(String translationKey, String namespaceId, int id, Material material, Supplier<IItemConvertible> crushResult) {
+        super(translationKey, namespaceId, id, material);
+        this.crushDrop = crushResult;
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
+        if (crushDrop != null && dropCause == EnumDropCause.PISTON_CRUSH) {
+            return new ItemStack[] {new ItemStack(crushDrop.get())};
+        }
+        return super.getBreakResult(world, dropCause, meta, blockEntity);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/DiamondOreBlock.java b/src/main/java/net/minecraft/core/block/DiamondOreBlock.java
index 163ca568f..3a3ce7607 100644
--- a/src/main/java/net/minecraft/core/block/DiamondOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/DiamondOreBlock.java
@@ -32,6 +32,7 @@ public class DiamondOreBlock extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.DIAMOND) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index 2e635f4c8..db5e9d83a 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -146,7 +146,7 @@ public class DoorBlock extends Block implements IPaintable
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(blockMaterial == Material.metal)
+        if(blockMaterial == Material.metal || blockMaterial == Material.steel)
         {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/FluidBlock.java b/src/main/java/net/minecraft/core/block/FluidBlock.java
index 500fd3601..e9a7cf6bf 100644
--- a/src/main/java/net/minecraft/core/block/FluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/FluidBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -265,7 +266,11 @@ public abstract class FluidBlock extends Block
                 int data = world.getBlockMetadata(x, y, z) & 0x0F;
                 if(data == 0)
                 {
-                    world.setBlockWithNotify(x, y, z, Blocks.OBSIDIAN.id);
+                    if (world.dimension == Dimension.NETHER) {
+                        world.setBlockWithNotify(x, y, z, Blocks.COBBLE_NETHERRACK_IGNEOUS.id);
+                    } else {
+                        world.setBlockWithNotify(x, y, z, Blocks.OBSIDIAN.id);
+                    }
                 }
                 else if(data <= 2)
                 {
diff --git a/src/main/java/net/minecraft/core/block/FurnaceBlock.java b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
index 3a4f3b836..8928ba6da 100644
--- a/src/main/java/net/minecraft/core/block/FurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
@@ -40,6 +40,7 @@ public class FurnaceBlock extends RotatableEntityBlock
             case EXPLOSION:
             case PROPER_TOOL:
             case SILK_TOUCH:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Blocks.FURNACE_STONE_IDLE) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/GoldOreBlock.java b/src/main/java/net/minecraft/core/block/GoldOreBlock.java
index 8464d5326..000ea2a6d 100644
--- a/src/main/java/net/minecraft/core/block/GoldOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/GoldOreBlock.java
@@ -29,6 +29,7 @@ public class GoldOreBlock extends Block {
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.ORE_RAW_GOLD) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/GravelBlock.java b/src/main/java/net/minecraft/core/block/GravelBlock.java
index 8589720fe..3bbad9999 100644
--- a/src/main/java/net/minecraft/core/block/GravelBlock.java
+++ b/src/main/java/net/minecraft/core/block/GravelBlock.java
@@ -22,6 +22,8 @@ public class GravelBlock extends SandBlock
     {
         switch (dropCause)
         {
+            case PISTON_CRUSH:
+                return new ItemStack[] { new ItemStack(Blocks.SAND)};
             case PICK_BLOCK:
             case SILK_TOUCH:
                 return new ItemStack[] { new ItemStack(this) };
diff --git a/src/main/java/net/minecraft/core/block/IgneousNetherrackBlock.java b/src/main/java/net/minecraft/core/block/IgneousNetherrackBlock.java
new file mode 100644
index 000000000..0d017a1d8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/IgneousNetherrackBlock.java
@@ -0,0 +1,67 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+import java.util.Random;
+
+public class IgneousNetherrackBlock extends Block{
+    public IgneousNetherrackBlock(String translationKey, String namespaceId, int id) {
+        super(translationKey, namespaceId, id, Material.netherrack);
+        setTicking(true);
+    }
+
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    {
+        float f = 0.125F;
+        return AABB.getTemporaryBB(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
+    }
+
+    @Override
+    public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
+    {
+        if (entity instanceof ItemEntity) return; // Don't burn items for this block
+        entity.fireHurt();
+    }
+
+    @Override
+    public int tickDelay() {
+        return 20;
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+    }
+
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+    }
+
+    public boolean canMelt(World world, int x, int y, int z) {
+        boolean canMelt = false;
+        for (Side side : Side.sides) {
+            Block block = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+            Material adjacentMaterial = block == null ? Material.air : block.blockMaterial;
+            if (adjacentMaterial == Material.water) {
+                return false;
+            }
+            canMelt |= adjacentMaterial == Material.lava;
+        }
+        return canMelt;
+    }
+
+    @Override
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+        if (canMelt(world, x, y, z)) {
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_LAVA_FLOWING.id);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/IronOreBlock.java b/src/main/java/net/minecraft/core/block/IronOreBlock.java
index a9828e0d7..a328886d6 100644
--- a/src/main/java/net/minecraft/core/block/IronOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/IronOreBlock.java
@@ -28,6 +28,7 @@ public class IronOreBlock extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.ORE_RAW_IRON) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/LapisOreBlock.java b/src/main/java/net/minecraft/core/block/LapisOreBlock.java
index 3128dd791..dadb34398 100644
--- a/src/main/java/net/minecraft/core/block/LapisOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/LapisOreBlock.java
@@ -5,6 +5,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
 import java.util.HashMap;
@@ -29,7 +30,8 @@ public class LapisOreBlock extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Items.DYE, 4 + world.rand.nextInt(5), 4) };
+            case PISTON_CRUSH:
+                return new ItemStack[] { new ItemStack(Items.DYE, 4 + world.rand.nextInt(5), DyeColor.BLUE.itemMeta) };
             default:
                 return null;
         }
diff --git a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
index a1a0153e4..294347af4 100644
--- a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
+++ b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
@@ -1,6 +1,7 @@
 
 package net.minecraft.core.block;
 
+import java.util.Objects;
 import java.util.Random;
 
 import net.minecraft.client.util.helper.Colors;
@@ -95,17 +96,10 @@ public class MotionSensorBlock extends VeryRotatableEntityBlock
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
-        switch (dropCause)
-        {
-            case WORLD:
-            case EXPLOSION:
-            case PROPER_TOOL:
-            case PICK_BLOCK:
-            case SILK_TOUCH:
-                return new ItemStack[] { new ItemStack(Blocks.MOTION_SENSOR_IDLE) };
-            default:
-                return null;
+        if (dropCause == EnumDropCause.IMPROPER_TOOL) {
+            return null;
         }
+        return new ItemStack[]{new ItemStack(Blocks.MOTION_SENSOR_IDLE)};
     }
     
     public static Direction getFacingDirection(int meta) {
diff --git a/src/main/java/net/minecraft/core/block/NetherCoalOreBlock.java b/src/main/java/net/minecraft/core/block/NetherCoalOreBlock.java
index 3a6b0db94..3318f66fa 100644
--- a/src/main/java/net/minecraft/core/block/NetherCoalOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/NetherCoalOreBlock.java
@@ -25,6 +25,7 @@ public class NetherCoalOreBlock extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.NETHERCOAL) };
             default:
                 return null;
